'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SchemaComposer = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _graphql = require('./graphql');

var _TypeStorage2 = require('./TypeStorage');

var _TypeMapper = require('./TypeMapper');

var _TypeComposer3 = require('./TypeComposer');

var _InputTypeComposer3 = require('./InputTypeComposer');

var _EnumTypeComposer3 = require('./EnumTypeComposer');

var _InterfaceTypeComposer2 = require('./InterfaceTypeComposer');

var _Resolver3 = require('./Resolver');

var _is = require('./utils/is');

var _typeHelpers = require('./utils/typeHelpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*  strict */
/* eslint-disable class-methods-use-this */

var SchemaComposer = exports.SchemaComposer = function (_TypeStorage) {
  (0, _inherits3.default)(SchemaComposer, _TypeStorage);

  function SchemaComposer() {
    (0, _classCallCheck3.default)(this, SchemaComposer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SchemaComposer.__proto__ || Object.getPrototypeOf(SchemaComposer)).call(this));

    _this._schemaMustHaveTypes = [];

    var schema = _this;

    var TypeComposer = function (_TypeComposer2) {
      (0, _inherits3.default)(TypeComposer, _TypeComposer2);

      function TypeComposer() {
        (0, _classCallCheck3.default)(this, TypeComposer);
        return (0, _possibleConstructorReturn3.default)(this, (TypeComposer.__proto__ || Object.getPrototypeOf(TypeComposer)).apply(this, arguments));
      }

      return TypeComposer;
    }(_TypeComposer3.TypeComposer);

    TypeComposer.schemaComposer = schema;

    _this.TypeComposer = TypeComposer;

    var InputTypeComposer = function (_InputTypeComposer2) {
      (0, _inherits3.default)(InputTypeComposer, _InputTypeComposer2);

      function InputTypeComposer() {
        (0, _classCallCheck3.default)(this, InputTypeComposer);
        return (0, _possibleConstructorReturn3.default)(this, (InputTypeComposer.__proto__ || Object.getPrototypeOf(InputTypeComposer)).apply(this, arguments));
      }

      return InputTypeComposer;
    }(_InputTypeComposer3.InputTypeComposer);

    InputTypeComposer.schemaComposer = schema;

    _this.InputTypeComposer = InputTypeComposer;

    var Resolver = function (_Resolver2) {
      (0, _inherits3.default)(Resolver, _Resolver2);

      function Resolver() {
        (0, _classCallCheck3.default)(this, Resolver);
        return (0, _possibleConstructorReturn3.default)(this, (Resolver.__proto__ || Object.getPrototypeOf(Resolver)).apply(this, arguments));
      }

      return Resolver;
    }(_Resolver3.Resolver);

    Resolver.schemaComposer = schema;

    _this.Resolver = Resolver;

    var EnumTypeComposer = function (_EnumTypeComposer2) {
      (0, _inherits3.default)(EnumTypeComposer, _EnumTypeComposer2);

      function EnumTypeComposer() {
        (0, _classCallCheck3.default)(this, EnumTypeComposer);
        return (0, _possibleConstructorReturn3.default)(this, (EnumTypeComposer.__proto__ || Object.getPrototypeOf(EnumTypeComposer)).apply(this, arguments));
      }

      return EnumTypeComposer;
    }(_EnumTypeComposer3.EnumTypeComposer);

    EnumTypeComposer.schemaComposer = schema;

    _this.EnumTypeComposer = EnumTypeComposer;

    var InterfaceTypeComposer = function (_InterfaceTypeCompose) {
      (0, _inherits3.default)(InterfaceTypeComposer, _InterfaceTypeCompose);

      function InterfaceTypeComposer() {
        (0, _classCallCheck3.default)(this, InterfaceTypeComposer);
        return (0, _possibleConstructorReturn3.default)(this, (InterfaceTypeComposer.__proto__ || Object.getPrototypeOf(InterfaceTypeComposer)).apply(this, arguments));
      }

      return InterfaceTypeComposer;
    }(_InterfaceTypeComposer2.InterfaceTypeComposer);

    InterfaceTypeComposer.schemaComposer = schema;

    _this.InterfaceTypeComposer = InterfaceTypeComposer;

    _this.typeMapper = new _TypeMapper.TypeMapper(schema);

    // alive proper Flow type casting in autosuggestions
    /* :: return this; */
    return _this;
  }

  (0, _createClass3.default)(SchemaComposer, [{
    key: 'rootQuery',
    value: function rootQuery() {
      return this.getOrCreateTC('Query');
    }
  }, {
    key: 'rootMutation',
    value: function rootMutation() {
      return this.getOrCreateTC('Mutation');
    }
  }, {
    key: 'rootSubscription',
    value: function rootSubscription() {
      return this.getOrCreateTC('Subscription');
    }
  }, {
    key: 'buildSchema',
    value: function buildSchema(extraConfig) {
      var roots = {};

      if (this.has('Query')) {
        var tc = this.getTC('Query');
        this.removeEmptyTypes(tc, new Set());
        roots.query = tc.getType();
      }

      if (this.has('Mutation')) {
        var _tc = this.getTC('Mutation');
        this.removeEmptyTypes(_tc, new Set());
        roots.mutation = _tc.getType();
      }

      if (this.has('Subscription')) {
        var _tc2 = this.getTC('Subscription');
        this.removeEmptyTypes(_tc2, new Set());
        roots.subscription = _tc2.getType();
      }

      if (Object.keys(roots).length === 0) {
        throw new Error('Can not build schema. Must be initialized at least one ' + 'of the following types: Query, Mutation, Subscription.');
      }

      var types = [].concat((0, _toConsumableArray3.default)(this._schemaMustHaveTypes.map(function (t) {
        return (0, _typeHelpers.getGraphQLType)(t);
      })), (0, _toConsumableArray3.default)(extraConfig && Array.isArray(extraConfig.types) ? [].concat((0, _toConsumableArray3.default)(extraConfig.types)) : []));

      return new _graphql.GraphQLSchema((0, _extends3.default)({}, roots, extraConfig, { types }));
    }
  }, {
    key: 'addSchemaMustHaveType',
    value: function addSchemaMustHaveType(type) {
      this._schemaMustHaveTypes.push(type);
      return this;
    }
  }, {
    key: 'removeEmptyTypes',
    value: function removeEmptyTypes(typeComposer) {
      var _this7 = this;

      var passedTypes = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new Set();

      var fieldsOrThunk = typeComposer.getType()._typeConfig.fields;
      var fields = (0, _is.isFunction)(fieldsOrThunk) ? fieldsOrThunk() : fieldsOrThunk;
      Object.keys(fields).forEach(function (fieldName) {
        var fieldType = fields[fieldName].type;
        if (fieldType instanceof _graphql.GraphQLObjectType) {
          var typeName = fieldType.name;
          if (!passedTypes.has(typeName)) {
            passedTypes.add(typeName);
            var tc = new _this7.TypeComposer(fieldType);
            if (Object.keys(tc.getFields()).length > 0) {
              _this7.removeEmptyTypes(tc, passedTypes);
            } else {
              // eslint-disable-next-line
              console.log(`graphql-compose: Delete field '${typeComposer.getTypeName()}.${fieldName}' ` + `with type '${tc.getTypeName()}', cause it does not have fields.`);
              typeComposer.removeField(fieldName);
              delete fields[fieldName];
            }
          }
        }
      });
    }
  }, {
    key: 'getOrCreateTC',
    value: function getOrCreateTC(typeName, onCreate) {
      if (!this.hasInstance(typeName, _TypeComposer3.TypeComposer)) {
        var tc = this.TypeComposer.create(typeName);
        this.set(typeName, tc);
        if (onCreate && (0, _is.isFunction)(onCreate)) onCreate(tc);
      }
      return this.get(typeName);
    }
  }, {
    key: 'getOrCreateITC',
    value: function getOrCreateITC(typeName, onCreate) {
      if (!this.hasInstance(typeName, _InputTypeComposer3.InputTypeComposer)) {
        var itc = this.InputTypeComposer.create(typeName);
        this.set(typeName, itc);
        if (onCreate && (0, _is.isFunction)(onCreate)) onCreate(itc);
      }
      return this.get(typeName);
    }
  }, {
    key: 'getOrCreateETC',
    value: function getOrCreateETC(typeName, onCreate) {
      if (!this.hasInstance(typeName, _EnumTypeComposer3.EnumTypeComposer)) {
        var etc = this.EnumTypeComposer.create(typeName);
        this.set(typeName, etc);
        if (onCreate && (0, _is.isFunction)(onCreate)) onCreate(etc);
      }
      return this.get(typeName);
    }
  }, {
    key: 'getOrCreateIFTC',
    value: function getOrCreateIFTC(typeName, onCreate) {
      if (!this.hasInstance(typeName, _InterfaceTypeComposer2.InterfaceTypeComposer)) {
        var iftc = this.InterfaceTypeComposer.create(typeName);
        this.set(typeName, iftc);
        if (onCreate && (0, _is.isFunction)(onCreate)) onCreate(iftc);
      }
      return this.get(typeName);
    }

    // disable redundant noise in console.logs

  }, {
    key: 'toString',
    value: function toString() {
      return 'SchemaComposer';
    }
  }, {
    key: 'toJSON',
    value: function toJSON() {
      return 'SchemaComposer';
    }
  }, {
    key: 'inspect',
    value: function inspect() {
      return 'SchemaComposer';
    }
  }, {
    key: 'clear',
    value: function clear() {
      (0, _get3.default)(SchemaComposer.prototype.__proto__ || Object.getPrototypeOf(SchemaComposer.prototype), 'clear', this).call(this);
      this._schemaMustHaveTypes = [];
    }
  }, {
    key: 'Query',
    get: function get() {
      return this.rootQuery();
    }
  }, {
    key: 'Mutation',
    get: function get() {
      return this.rootMutation();
    }
  }, {
    key: 'Subscription',
    get: function get() {
      return this.rootSubscription();
    }
  }]);
  return SchemaComposer;
}(_TypeStorage2.TypeStorage);