'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TypeStorage = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _is = require('./utils/is');

var _TypeComposer = require('./TypeComposer');

var _InputTypeComposer = require('./InputTypeComposer');

var _EnumTypeComposer = require('./EnumTypeComposer');

var _InterfaceTypeComposer = require('./InterfaceTypeComposer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TypeStorage has all methods from Map class
var TypeStorage = exports.TypeStorage = function () {
  function TypeStorage() {
    (0, _classCallCheck3.default)(this, TypeStorage);

    this.types = new Map();

    // alive proper Flow type casting in autosuggestions
    /* :: return this; */
  }

  (0, _createClass3.default)(TypeStorage, [{
    key: 'clear',
    value: function clear() {
      this.types.clear();
    }
  }, {
    key: 'delete',
    value: function _delete(typeName) {
      return this.types.delete(typeName);
    }
  }, {
    key: 'entries',
    value: function entries() {
      return this.types.entries();
    }
  }, {
    key: 'forEach',
    value: function forEach(callbackfn, thisArg) {
      return this.types.forEach(callbackfn, thisArg);
    }
  }, {
    key: 'get',
    value: function get(typeName) {
      var v = this.types.get(typeName);
      if (!v) {
        throw new Error(`Type with name ${JSON.stringify(typeName)} does not exists in TypeStorage`);
      }
      return v;
    }
  }, {
    key: 'has',
    value: function has(typeName) {
      return this.types.has(typeName);
    }
  }, {
    key: 'keys',
    value: function keys() {
      return this.types.keys();
    }
  }, {
    key: 'set',
    value: function set(typeName, value) {
      this.types.set(typeName, value);
      return this;
    }
  }, {
    key: 'values',
    value: function values() {
      return this.types.values();
    }
  }, {
    key: 'add',
    value: function add(value) {
      if (value) {
        var typeName = void 0;
        if (value.getTypeName && value.getTypeName.call) {
          // $FlowFixMe
          typeName = value.getTypeName();
        } else if (value.name) {
          typeName = value.name;
        }

        if (typeName) {
          this.set(typeName, value);
          return typeName;
        }
      }
      return null;
    }
  }, {
    key: 'hasInstance',
    value: function hasInstance(typeName, ClassObj) {
      if (!this.has(typeName)) return false;
      var existedType = this.get(typeName);
      if (existedType && existedType instanceof ClassObj) {
        return true;
      }
      return false;
    }
  }, {
    key: 'getOrSet',
    value: function getOrSet(typeName, typeOrThunk) {
      var existedType = this.types.get(typeName);
      if (existedType) {
        return existedType;
      }

      var gqType = (0, _is.isFunction)(typeOrThunk) ? typeOrThunk() : typeOrThunk;
      if (gqType) {
        this.set(typeName, gqType);
      }

      return gqType;
    }
  }, {
    key: 'getTC',
    value: function getTC(typeName) {
      if (!this.hasInstance(typeName, _TypeComposer.TypeComposer)) {
        throw new Error(`Cannot find TypeComposer with name ${typeName}`);
      }
      return this.get(typeName);
    }
  }, {
    key: 'getITC',
    value: function getITC(typeName) {
      if (!this.hasInstance(typeName, _InputTypeComposer.InputTypeComposer)) {
        throw new Error(`Cannot find InputTypeComposer with name ${typeName}`);
      }
      return this.get(typeName);
    }
  }, {
    key: 'getETC',
    value: function getETC(typeName) {
      if (!this.hasInstance(typeName, _EnumTypeComposer.EnumTypeComposer)) {
        throw new Error(`Cannot find EnumTypeComposer with name ${typeName}`);
      }
      return this.get(typeName);
    }
  }, {
    key: 'getIFTC',
    value: function getIFTC(typeName) {
      if (!this.hasInstance(typeName, _InterfaceTypeComposer.InterfaceTypeComposer)) {
        throw new Error(`Cannot find InterfaceTypeComposer with name ${typeName}`);
      }
      return this.get(typeName);
    }
  }, {
    key: 'size',
    get: function get() {
      return this.types.size;
    }
  }]);
  return TypeStorage;
}(); /*  strict */